org.apache.tinkerpop.gremlin.process.computer.traversal.step.map

## Class PeerPressureVertexProgramStep

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<ComputerResult,ComputerResult>
  - - org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.VertexProgramStep
    - - org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.PeerPressureVertexProgramStep

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<ComputerResult>>, VertexComputing, Step<ComputerResult,ComputerResult>, ByModulating, Configuring, Parameterizing, TimesModulating, TraversalParent

      public final class PeerPressureVertexProgramStep
      extends VertexProgramStep
      implements TraversalParent, ByModulating, TimesModulating, Configuring

  Author:
    Marko A. Rodriguez (http://markorodriguez.com), Stephen Mallette (http://stephen.genoprime.com)
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.VertexProgramStep

      `computer, first, ROOT_TRAVERSAL, STEP_ID`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PeerPressureVertexProgramStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `PeerPressureVertexProgramStep` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `void` | `configure(Object... keyValues)` Accept a configuration to the `Step`.
    `PeerPressureVertexProgram` | `generateProgram(Graph graph, Memory memory)` Generate the `VertexProgram`.
    `List<Traversal.Admin<Vertex,Edge>>` | `getLocalChildren()`
    `Parameters` | `getParameters()` Gets the parameters on the step.
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `void` | `modulateBy(String clusterProperty)` Deprecated. As of release 3.4.0, replaced by `configure(Object...)`
    `void` | `modulateBy(Traversal.Admin<?,?> edgeTraversal)` Deprecated. As of release 3.4.0, replaced by `configure(Object...)`
    `void` | `modulateTimes(int times)` Deprecated. As of release 3.4.0, replaced by `configure(Object...)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.VertexProgramStep

      `getComputer, isEndStep, previousTraversalVertexProgram, processNextStart, setComputer`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, reset, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### PeerPressureVertexProgramStep

          public PeerPressureVertexProgramStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### configure

          public void configure(Object... keyValues)

      Description copied from interface: `Configuring`
      Accept a configuration to the `Step`. Note that this interface extends `Parameterizing` and so there is an expectation that the `Step` implementation will have a `Parameters` instance that will house any values passed to this method. Storing these configurations in `Parameters` is not a requirement however, IF the configuration is an expected option for the step and can be stored on a member field that can be accessed on the step by more direct means (i.e. like a getter method).
      Specified by:
        `configure` in interface `Configuring`

    - #### getParameters

          public Parameters getParameters()

      Description copied from interface: `Parameterizing`
      Gets the parameters on the step.
      Specified by:
        `getParameters` in interface `Parameterizing`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<ComputerResult,ComputerResult>`

    - #### modulateBy

          @Deprecated
          public void modulateBy(Traversal.Admin<?,?> edgeTraversal)

      Deprecated. As of release 3.4.0, replaced by `configure(Object...)`
      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### modulateBy

          @Deprecated
          public void modulateBy(String clusterProperty)

      Deprecated. As of release 3.4.0, replaced by `configure(Object...)`
      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### modulateTimes

          @Deprecated
          public void modulateTimes(int times)

      Deprecated. As of release 3.4.0, replaced by `configure(Object...)`
      Specified by:
        `modulateTimes` in interface `TimesModulating`

    - #### getLocalChildren

          public List<Traversal.Admin<Vertex,Edge>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<ComputerResult,ComputerResult>`

    - #### generateProgram

          public PeerPressureVertexProgram generateProgram(Graph graph,
                                                           Memory memory)

      Description copied from interface: `VertexComputing`
      Generate the `VertexProgram`.
      Specified by:
        `generateProgram` in interface `VertexComputing`
      Parameters:
        `graph` - the `Graph` that the program will be executed over.
        `memory` - the `Memory` from the previous OLAP job if it exists, else its an empty memory structure.
      Returns:
        the generated vertex program instance.

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<ComputerResult,ComputerResult>`
      Returns:
        the set of requirements

    - #### clone

          public PeerPressureVertexProgramStep clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<ComputerResult,ComputerResult>`
      Overrides:
        `clone` in class `AbstractStep<ComputerResult,ComputerResult>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<ComputerResult,ComputerResult>`
      Overrides:
        `setTraversal` in class `AbstractStep<ComputerResult,ComputerResult>`
      Parameters:
        `parentTraversal` - the new traversal for this step

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.